// u_c_zzz
// 2013-02-09

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_direct_interfact_implementation;
  interface
    uses u_c_person;

    type i_equal_to<T>=
             interface
               function f_are_equal(p_c_one, p_c_two: T): Boolean;
               function f_display(p_c_T: T): String;
             end;

         c_item_list =
             Class(tInterfacedObject, i_equal_to<c_person>)
               m_array: array of c_person;

               // -- i_equal_to
               function f_are_equal(p_c_one, p_c_two: c_person): Boolean;
               function f_display(p_c_T: c_person): String;

               procedure add_item(p_item: c_person);
               function f_indexof(p_item: c_person): Integer;
             End; // c_item_list

  implementation
    uses SysUtils, u_display_simple;

    function c_item_list.f_display(p_c_T: c_person): String;
      begin
        Result:= p_c_T.m_first_name;
      end; // f_display

    function c_item_list.f_are_equal(p_c_one, p_c_two: c_person): Boolean;
      begin
        Result:= p_c_one.m_first_name= p_c_two.m_first_name;
      end; // f_equal_to

    procedure c_item_list.add_item(p_item: c_person);
      begin
        SetLength(m_array, Length(m_array)+ 1);
        m_array[Length(m_array)- 1]:= p_item;
      end; // add_item

    function c_item_list.f_indexof(p_item: c_person): Integer;
      var l_index: Integer;
      begin
        for l_index := 0 to Length(m_array) - 1 do
        begin
          display(Format('%2d  %s', [l_index, f_display(m_array[l_index])]));
          // -- compiler did accept c_person.f_equal_to
          if f_are_equal(m_array[l_index], p_item)
            then begin
                Result:= l_index;
                Break;
              end;
        end;
      end; // f_indexof

    end. // u_c_zzz


